package CalculiX;


import java.io.Reader;

import java_cup.runtime.Symbol;

public class MyLexer {
	private final Lexer l;
	private Token next;
	MyLexer(Reader in) {
		l = new Lexer(in);
		next = null;
	}
	
	private void getNext() {
		if (next != null) return;
		try{
			Symbol s = l.next_token();
			assert (s != null);
			next = new Token(s.sym,s.left, s.right, s.value);
			}
		catch (Exception e){
			throw new RuntimeException("Lexer exception: "+e.toString());
		}

	}

	Token peek() {
		getNext();
		return next;
	}

	Token consumeToken() {
		getNext();
		assert (next.symbol != Symbols.EOF);
		Token ret = next;
		
		next = null;
		getNext();
		return(ret);
	}
	
	Token consumeToken(int expected) throws SyntaxError {
		Token actual = peek();
	    if (actual.symbol == expected)
	      return consumeToken();
	    else
	      throw actual.syntaxError ("expected " + Token.showSymbol(expected));
	}
	

}
