package CalculiX;

// This class implements a hand-written directional deterministic parser.
// It relies on the classes MyLexer and ExpressionFactory.

import static CalculiX.Symbols.*;

class MyParser {

  // The lexer that we are using to read tokens.
  private final MyLexer lexer;

  // The factory that we are using to construct expressions.
  private final ExpressionFactory factory;

  // Constructor.

  MyParser (MyLexer lexer, ExpressionFactory factory)
  {
    this.lexer = lexer;
    this.factory = factory;
  }

  // Each of the methods that follow corresponds to a single non-terminal
  // symbol in our grammar.


  Expression consumeExpression () throws SyntaxError
  {
    return null;
  }

  Expression parse () throws SyntaxError
  {
    Expression e = consumeExpression();
    Token t = lexer.peek();
    switch (t.symbol) {
    case EOF:
      return e;
    default:
      throw t.syntaxError ("expected EOF");
    }
  }

}

