package CalculiX;

public class Token {
	int symbol;
	int line;
	int column;
	Object value;
	
	Token(int s, int l, int c, Object v){
	    symbol = s;
		line = l;
		column = c;
		value = v;
	}
	
	int symbol(){return symbol;}
	
	int asInteger(){
		if (value instanceof Integer) {return ((Integer) value);}
		else throw new RuntimeException("Given symbol does not contain an integer.");
	}
	
	String asString(){
		if (value instanceof String) {return ((String) value);}
		else throw new RuntimeException("Given symbol does not contain a string.");
	}
	
	SyntaxError syntaxError(String s){
		return new SyntaxError("Line:"+line+", Column:"+column+", Symbol:"+showSymbol(symbol)+" "+s);
		
	}
	public String toString(){ 
			return ("Line:"+line+", Column:"+column+", Symbol:"+showSymbol(symbol)); 
	}
	
	static String showSymbol (int token)
	  {
	    try {
	      java.lang.reflect.Field [] classFields = Symbols.class.getFields();
	      for (int i = 0; i < classFields.length; i++) {
		if (classFields[i].getInt(null) == token) {
		  return classFields[i].getName();
		}
	      }
	    } catch (java.lang.IllegalAccessException e) {
	    }
	    throw new AssertionError (); // hopefully unreachable statement
	  }


}
