package CalculiX;

abstract class Value {

  // Values include Boolean values and integer values.

  // The following methods attempt to cast a value down to one of
  // these forms, and fail if the value is not of the expected form.

  // The default implementations of these methods cause a failure.
  // Each of them is redefined in one sub-class only, as appropriate.

  boolean asBoolean () throws EvalException
  {
    throw new EvalException (
      "Expected a Boolean value, but got " + this + " instead."
    );
  }

  int asInteger () throws EvalException
  {
    throw new EvalException (
      "Expected an integer value, but got " + this + " instead."
    );
  }

}

